package game

import (
	"net"
)

// Ping is used as a heartbeat and latency check.
func (game *Game) Ping(data []byte, address *net.UDPAddr) error {
	game.server.Send(Ping, data[:1], address)

	if game.players.Contains(address) {
		game.players.ByAddress(address).KeepAlive()
	}

	return nil
}
